<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kd7w2jm6rvvx6pnfgbmafdxkx875y5cf-vendored-sources/gimli-0.26.2/src/common.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>common.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../gimli/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../gimli/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../gimli/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
</pre><pre class="rust"><code><span class="doccomment">/// Whether the format of a compilation unit is 32- or 64-bit.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">Format</span> {
    <span class="doccomment">/// 64-bit DWARF</span>
    <span class="ident">Dwarf64</span> <span class="op">=</span> <span class="number">8</span>,
    <span class="doccomment">/// 32-bit DWARF</span>
    <span class="ident">Dwarf32</span> <span class="op">=</span> <span class="number">4</span>,
}

<span class="kw">impl</span> <span class="ident">Format</span> {
    <span class="doccomment">/// Return the serialized size of an initial length field for the format.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">initial_length_size</span>(<span class="self">self</span>) -&gt; <span class="ident">u8</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">Format::Dwarf32</span> =&gt; <span class="number">4</span>,
            <span class="ident">Format::Dwarf64</span> =&gt; <span class="number">12</span>,
        }
    }

    <span class="doccomment">/// Return the natural word size for the format</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">word_size</span>(<span class="self">self</span>) -&gt; <span class="ident">u8</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">Format::Dwarf32</span> =&gt; <span class="number">4</span>,
            <span class="ident">Format::Dwarf64</span> =&gt; <span class="number">8</span>,
        }
    }
}

<span class="doccomment">/// Encoding parameters that are commonly used for multiple DWARF sections.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This is intended to be small enough to pass by value.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="comment">// `address_size` and `format` are used more often than `version`, so keep</span>
<span class="comment">// them first.</span>
<span class="attribute">#[<span class="ident">repr</span>(<span class="ident">C</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Encoding</span> {
    <span class="doccomment">/// The size of an address.</span>
    <span class="kw">pub</span> <span class="ident">address_size</span>: <span class="ident">u8</span>,

    <span class="comment">// The size of a segment selector.</span>
    <span class="comment">// TODO: pub segment_size: u8,</span>
    <span class="doccomment">/// Whether the DWARF format is 32- or 64-bit.</span>
    <span class="kw">pub</span> <span class="ident">format</span>: <span class="ident">Format</span>,

    <span class="doccomment">/// The DWARF version of the header.</span>
    <span class="kw">pub</span> <span class="ident">version</span>: <span class="ident">u16</span>,
}

<span class="doccomment">/// Encoding parameters for a line number program.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">LineEncoding</span> {
    <span class="doccomment">/// The size in bytes of the smallest target machine instruction.</span>
    <span class="kw">pub</span> <span class="ident">minimum_instruction_length</span>: <span class="ident">u8</span>,

    <span class="doccomment">/// The maximum number of individual operations that may be encoded in an</span>
    <span class="doccomment">/// instruction.</span>
    <span class="kw">pub</span> <span class="ident">maximum_operations_per_instruction</span>: <span class="ident">u8</span>,

    <span class="doccomment">/// The initial value of the `is_stmt` register.</span>
    <span class="kw">pub</span> <span class="ident">default_is_stmt</span>: <span class="ident">bool</span>,

    <span class="doccomment">/// The minimum value which a special opcode can add to the line register.</span>
    <span class="kw">pub</span> <span class="ident">line_base</span>: <span class="ident">i8</span>,

    <span class="doccomment">/// The range of values which a special opcode can add to the line register.</span>
    <span class="kw">pub</span> <span class="ident">line_range</span>: <span class="ident">u8</span>,
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">LineEncoding</span> {
    <span class="kw">fn</span> <span class="ident">default</span>() -&gt; <span class="self">Self</span> {
        <span class="comment">// Values from LLVM.</span>
        <span class="ident">LineEncoding</span> {
            <span class="ident">minimum_instruction_length</span>: <span class="number">1</span>,
            <span class="ident">maximum_operations_per_instruction</span>: <span class="number">1</span>,
            <span class="ident">default_is_stmt</span>: <span class="bool-val">true</span>,
            <span class="ident">line_base</span>: <span class="op">-</span><span class="number">5</span>,
            <span class="ident">line_range</span>: <span class="number">14</span>,
        }
    }
}

<span class="doccomment">/// A DWARF register number.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The meaning of this value is ABI dependent. This is generally encoded as</span>
<span class="doccomment">/// a ULEB128, but supported architectures need 16 bits at most.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>, <span class="ident">PartialOrd</span>, <span class="ident">Ord</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Register</span>(<span class="kw">pub</span> <span class="ident">u16</span>);

<span class="doccomment">/// An offset into the `.debug_abbrev` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugAbbrevOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An offset to a set of entries in the `.debug_addr` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugAddrBase</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An index into a set of addresses in the `.debug_addr` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugAddrIndex</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An offset into the `.debug_aranges` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugArangesOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An offset into the `.debug_info` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Ord</span>, <span class="ident">PartialOrd</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugInfoOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An offset into the `.debug_line` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugLineOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An offset into the `.debug_line_str` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugLineStrOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An offset into either the `.debug_loc` section or the `.debug_loclists` section,</span>
<span class="doccomment">/// depending on the version of the unit the offset was contained in.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">LocationListsOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An offset to a set of location list offsets in the `.debug_loclists` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugLocListsBase</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An index into a set of location list offsets in the `.debug_loclists` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugLocListsIndex</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An offset into the `.debug_macinfo` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugMacinfoOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An offset into the `.debug_macro` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugMacroOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An offset into either the `.debug_ranges` section or the `.debug_rnglists` section,</span>
<span class="doccomment">/// depending on the version of the unit the offset was contained in.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// If this is from a DWARF 4 DWO file, then it must additionally be offset by the</span>
<span class="doccomment">/// value of `DW_AT_GNU_ranges_base`. You can use `Dwarf::ranges_offset_from_raw` to do this.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">RawRangeListsOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An offset into either the `.debug_ranges` section or the `.debug_rnglists` section,</span>
<span class="doccomment">/// depending on the version of the unit the offset was contained in.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">RangeListsOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An offset to a set of range list offsets in the `.debug_rnglists` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugRngListsBase</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An index into a set of range list offsets in the `.debug_rnglists` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugRngListsIndex</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An offset into the `.debug_str` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugStrOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An offset to a set of entries in the `.debug_str_offsets` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugStrOffsetsBase</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An index into a set of entries in the `.debug_str_offsets` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugStrOffsetsIndex</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// An offset into the `.debug_types` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Ord</span>, <span class="ident">PartialOrd</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugTypesOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="doccomment">/// A type signature as used in the `.debug_types` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugTypeSignature</span>(<span class="kw">pub</span> <span class="ident">u64</span>);

<span class="doccomment">/// An offset into the `.debug_frame` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DebugFrameOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">From</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">DebugFrameOffset</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">o</span>: <span class="ident">T</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">DebugFrameOffset</span>(<span class="ident">o</span>)
    }
}

<span class="doccomment">/// An offset into the `.eh_frame` section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">EhFrameOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">From</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">EhFrameOffset</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">o</span>: <span class="ident">T</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">EhFrameOffset</span>(<span class="ident">o</span>)
    }
}

<span class="doccomment">/// An offset into the `.debug_info` or `.debug_types` sections.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Ord</span>, <span class="ident">PartialOrd</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">UnitSectionOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span> {
    <span class="doccomment">/// An offset into the `.debug_info` section.</span>
    <span class="ident">DebugInfoOffset</span>(<span class="ident">DebugInfoOffset</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>),
    <span class="doccomment">/// An offset into the `.debug_types` section.</span>
    <span class="ident">DebugTypesOffset</span>(<span class="ident">DebugTypesOffset</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>),
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">From</span><span class="op">&lt;</span><span class="ident">DebugInfoOffset</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">UnitSectionOffset</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">offset</span>: <span class="ident">DebugInfoOffset</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">UnitSectionOffset::DebugInfoOffset</span>(<span class="ident">offset</span>)
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">From</span><span class="op">&lt;</span><span class="ident">DebugTypesOffset</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">UnitSectionOffset</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">offset</span>: <span class="ident">DebugTypesOffset</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">UnitSectionOffset::DebugTypesOffset</span>(<span class="ident">offset</span>)
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">UnitSectionOffset</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">T</span>: <span class="ident">Clone</span>,
{
    <span class="doccomment">/// Returns the `DebugInfoOffset` inside, or `None` otherwise.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">as_debug_info_offset</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">DebugInfoOffset</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">UnitSectionOffset::DebugInfoOffset</span>(<span class="ident">offset</span>) =&gt; <span class="prelude-val">Some</span>(<span class="ident">offset</span>.<span class="ident">clone</span>()),
            <span class="ident">UnitSectionOffset::DebugTypesOffset</span>(<span class="kw">_</span>) =&gt; <span class="prelude-val">None</span>,
        }
    }
    <span class="doccomment">/// Returns the `DebugTypesOffset` inside, or `None` otherwise.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">as_debug_types_offset</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">DebugTypesOffset</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">UnitSectionOffset::DebugInfoOffset</span>(<span class="kw">_</span>) =&gt; <span class="prelude-val">None</span>,
            <span class="ident">UnitSectionOffset::DebugTypesOffset</span>(<span class="ident">offset</span>) =&gt; <span class="prelude-val">Some</span>(<span class="ident">offset</span>.<span class="ident">clone</span>()),
        }
    }
}

<span class="doccomment">/// An identifier for a DWARF section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Ord</span>, <span class="ident">PartialOrd</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">SectionId</span> {
    <span class="doccomment">/// The `.debug_abbrev` section.</span>
    <span class="ident">DebugAbbrev</span>,
    <span class="doccomment">/// The `.debug_addr` section.</span>
    <span class="ident">DebugAddr</span>,
    <span class="doccomment">/// The `.debug_aranges` section.</span>
    <span class="ident">DebugAranges</span>,
    <span class="doccomment">/// The `.debug_cu_index` section.</span>
    <span class="ident">DebugCuIndex</span>,
    <span class="doccomment">/// The `.debug_frame` section.</span>
    <span class="ident">DebugFrame</span>,
    <span class="doccomment">/// The `.eh_frame` section.</span>
    <span class="ident">EhFrame</span>,
    <span class="doccomment">/// The `.eh_frame_hdr` section.</span>
    <span class="ident">EhFrameHdr</span>,
    <span class="doccomment">/// The `.debug_info` section.</span>
    <span class="ident">DebugInfo</span>,
    <span class="doccomment">/// The `.debug_line` section.</span>
    <span class="ident">DebugLine</span>,
    <span class="doccomment">/// The `.debug_line_str` section.</span>
    <span class="ident">DebugLineStr</span>,
    <span class="doccomment">/// The `.debug_loc` section.</span>
    <span class="ident">DebugLoc</span>,
    <span class="doccomment">/// The `.debug_loclists` section.</span>
    <span class="ident">DebugLocLists</span>,
    <span class="doccomment">/// The `.debug_macinfo` section.</span>
    <span class="ident">DebugMacinfo</span>,
    <span class="doccomment">/// The `.debug_macro` section.</span>
    <span class="ident">DebugMacro</span>,
    <span class="doccomment">/// The `.debug_pubnames` section.</span>
    <span class="ident">DebugPubNames</span>,
    <span class="doccomment">/// The `.debug_pubtypes` section.</span>
    <span class="ident">DebugPubTypes</span>,
    <span class="doccomment">/// The `.debug_ranges` section.</span>
    <span class="ident">DebugRanges</span>,
    <span class="doccomment">/// The `.debug_rnglists` section.</span>
    <span class="ident">DebugRngLists</span>,
    <span class="doccomment">/// The `.debug_str` section.</span>
    <span class="ident">DebugStr</span>,
    <span class="doccomment">/// The `.debug_str_offsets` section.</span>
    <span class="ident">DebugStrOffsets</span>,
    <span class="doccomment">/// The `.debug_tu_index` section.</span>
    <span class="ident">DebugTuIndex</span>,
    <span class="doccomment">/// The `.debug_types` section.</span>
    <span class="ident">DebugTypes</span>,
}

<span class="kw">impl</span> <span class="ident">SectionId</span> {
    <span class="doccomment">/// Returns the ELF section name for this kind.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">name</span>(<span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">SectionId::DebugAbbrev</span> =&gt; <span class="string">&quot;.debug_abbrev&quot;</span>,
            <span class="ident">SectionId::DebugAddr</span> =&gt; <span class="string">&quot;.debug_addr&quot;</span>,
            <span class="ident">SectionId::DebugAranges</span> =&gt; <span class="string">&quot;.debug_aranges&quot;</span>,
            <span class="ident">SectionId::DebugCuIndex</span> =&gt; <span class="string">&quot;.debug_cu_index&quot;</span>,
            <span class="ident">SectionId::DebugFrame</span> =&gt; <span class="string">&quot;.debug_frame&quot;</span>,
            <span class="ident">SectionId::EhFrame</span> =&gt; <span class="string">&quot;.eh_frame&quot;</span>,
            <span class="ident">SectionId::EhFrameHdr</span> =&gt; <span class="string">&quot;.eh_frame_hdr&quot;</span>,
            <span class="ident">SectionId::DebugInfo</span> =&gt; <span class="string">&quot;.debug_info&quot;</span>,
            <span class="ident">SectionId::DebugLine</span> =&gt; <span class="string">&quot;.debug_line&quot;</span>,
            <span class="ident">SectionId::DebugLineStr</span> =&gt; <span class="string">&quot;.debug_line_str&quot;</span>,
            <span class="ident">SectionId::DebugLoc</span> =&gt; <span class="string">&quot;.debug_loc&quot;</span>,
            <span class="ident">SectionId::DebugLocLists</span> =&gt; <span class="string">&quot;.debug_loclists&quot;</span>,
            <span class="ident">SectionId::DebugMacinfo</span> =&gt; <span class="string">&quot;.debug_macinfo&quot;</span>,
            <span class="ident">SectionId::DebugMacro</span> =&gt; <span class="string">&quot;.debug_macro&quot;</span>,
            <span class="ident">SectionId::DebugPubNames</span> =&gt; <span class="string">&quot;.debug_pubnames&quot;</span>,
            <span class="ident">SectionId::DebugPubTypes</span> =&gt; <span class="string">&quot;.debug_pubtypes&quot;</span>,
            <span class="ident">SectionId::DebugRanges</span> =&gt; <span class="string">&quot;.debug_ranges&quot;</span>,
            <span class="ident">SectionId::DebugRngLists</span> =&gt; <span class="string">&quot;.debug_rnglists&quot;</span>,
            <span class="ident">SectionId::DebugStr</span> =&gt; <span class="string">&quot;.debug_str&quot;</span>,
            <span class="ident">SectionId::DebugStrOffsets</span> =&gt; <span class="string">&quot;.debug_str_offsets&quot;</span>,
            <span class="ident">SectionId::DebugTuIndex</span> =&gt; <span class="string">&quot;.debug_tu_index&quot;</span>,
            <span class="ident">SectionId::DebugTypes</span> =&gt; <span class="string">&quot;.debug_types&quot;</span>,
        }
    }

    <span class="doccomment">/// Returns the ELF section name for this kind, when found in a .dwo or .dwp file.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">dwo_name</span>(<span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span><span class="op">&gt;</span> {
        <span class="prelude-val">Some</span>(<span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">SectionId::DebugAbbrev</span> =&gt; <span class="string">&quot;.debug_abbrev.dwo&quot;</span>,
            <span class="ident">SectionId::DebugCuIndex</span> =&gt; <span class="string">&quot;.debug_cu_index&quot;</span>,
            <span class="ident">SectionId::DebugInfo</span> =&gt; <span class="string">&quot;.debug_info.dwo&quot;</span>,
            <span class="ident">SectionId::DebugLine</span> =&gt; <span class="string">&quot;.debug_line.dwo&quot;</span>,
            <span class="comment">// The debug_loc section can be present in the dwo when using the</span>
            <span class="comment">// GNU split-dwarf extension to DWARF4.</span>
            <span class="ident">SectionId::DebugLoc</span> =&gt; <span class="string">&quot;.debug_loc.dwo&quot;</span>,
            <span class="ident">SectionId::DebugLocLists</span> =&gt; <span class="string">&quot;.debug_loclists.dwo&quot;</span>,
            <span class="ident">SectionId::DebugMacro</span> =&gt; <span class="string">&quot;.debug_macro.dwo&quot;</span>,
            <span class="ident">SectionId::DebugRngLists</span> =&gt; <span class="string">&quot;.debug_rnglists.dwo&quot;</span>,
            <span class="ident">SectionId::DebugStr</span> =&gt; <span class="string">&quot;.debug_str.dwo&quot;</span>,
            <span class="ident">SectionId::DebugStrOffsets</span> =&gt; <span class="string">&quot;.debug_str_offsets.dwo&quot;</span>,
            <span class="ident">SectionId::DebugTuIndex</span> =&gt; <span class="string">&quot;.debug_tu_index&quot;</span>,
            <span class="ident">SectionId::DebugTypes</span> =&gt; <span class="string">&quot;.debug_types.dwo&quot;</span>,
            <span class="kw">_</span> =&gt; <span class="kw">return</span> <span class="prelude-val">None</span>,
        })
    }
}

<span class="doccomment">/// An optionally-provided implementation-defined compilation unit ID to enable</span>
<span class="doccomment">/// split DWARF and linking a split compilation unit back together.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DwoId</span>(<span class="kw">pub</span> <span class="ident">u64</span>);

<span class="doccomment">/// The &quot;type&quot; of file with DWARF debugging information. This determines, among other things,</span>
<span class="doccomment">/// which files DWARF sections should be loaded from.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">DwarfFileType</span> {
    <span class="doccomment">/// A normal executable or object file.</span>
    <span class="ident">Main</span>,
    <span class="doccomment">/// A .dwo split DWARF file.</span>
    <span class="ident">Dwo</span>,
    <span class="comment">// TODO: Supplementary files, .dwps?</span>
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">DwarfFileType</span> {
    <span class="kw">fn</span> <span class="ident">default</span>() -&gt; <span class="self">Self</span> {
        <span class="ident">DwarfFileType::Main</span>
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="gimli" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>